#!/usr/bin/env bash
set -e

LOCAL_IMAGE=xaicorp/acme-nginx
REMOTE_IMAGE=dkregistry.xai-corp.net:5000/xaicorp/acme-nginx

build() {
  docker build --rm -f Dockerfile -t xaicorp/acme-nginx .
}

build_test() {
  echo testing the image
  docker run --rm --entrypoint=ls $LOCAL_IMAGE -l /usr/local/bin | grep acme-nginx
  docker run --rm $LOCAL_IMAGE -h | grep 'usage: acme-nginx'
}

build_deploy() {
  echo push to registry

  docker tag $LOCAL_IMAGE $REMOTE_IMAGE
  docker push $REMOTE_IMAGE
}

print_usage() {
  printf "Usage: %s: [-b] [-t] [-d] \n" "$0"
  echo -b build
  echo -t test
  echo -d push to registry
  echo -h help
  exit 0
}

######
if [ -z "$1" ]; then
  build && build_test && build_deploy
  exit
fi

while getopts btdh name
do
    case $name in
    b)    build;;
    t)    build_test;;
    d)    build_deploy;;
    *)    print_usage;;
    esac
done
